commit 23f6af8d0df7278f3532a3c16afb6512dc1d0dfb
Author: freddy77 <freddy77>
Date:   Mon Mar 22 14:42:16 2010 +0000

    fix descrec test

diff --git a/ChangeLog b/ChangeLog
index ca9f089..866fa2d 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Mon Mar 22 15:41:47 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c: fix descrec test
+
 Wed Mar  3 09:08:14 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/write.c: compute length supporting all character sets
 
@@ -2362,4 +2365,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2999 2010/03/03 08:08:56 freddy77 Exp $
+$Id: ChangeLog,v 1.3000 2010/03/22 14:42:16 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 0546599..466847b 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.530 2010/03/02 15:41:37 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.531 2010/03/22 14:42:16 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv, SQLINTEGER odbc_version);
@@ -2273,14 +2273,14 @@ SQLGetDescRec(SQLHDESC hdesc, SQLSMALLINT RecordNumber, SQLCHAR * Name, SQLSMALL
 		ODBC_RETURN(desc, SQL_ERROR);
 	}
 
-	if (desc->type == DESC_IRD && desc->header.sql_desc_count) {
+	if (RecordNumber > desc->header.sql_desc_count)
+		ODBC_RETURN(desc, SQL_NO_DATA);
+
+	if (desc->type == DESC_IRD && !desc->header.sql_desc_count) {
 		odbc_errs_add(&desc->errs, "HY007", NULL);
 		ODBC_RETURN(desc, SQL_ERROR);
 	}
 
-	if (RecordNumber > desc->header.sql_desc_count)
-		ODBC_RETURN(desc, SQL_NO_DATA);
-
 	drec = &desc->records[RecordNumber - 1];
 
 	if ((rc = odbc_set_string(Name, BufferLength, StringLength, tds_dstr_cstr(&drec->sql_desc_name), -1)) != SQL_SUCCESS)

